import { isOn, set } from 'feature-toggle-service';
import { Component, Input, ElementRef, NgZone, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FeatureToggleComponent = /** @class */ (function () {
    function FeatureToggleComponent(_el, _zone) {
        this._el = _el;
        this._zone = _zone;
    }
    /**
     * @return {?}
     */
    FeatureToggleComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.featureName) {
            throw new Error('Attribute `featureName` should not be null or empty');
        }
        this.shouldRender();
    };
    /**
     * @return {?}
     */
    FeatureToggleComponent.prototype.ngDoCheck = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this._zone.runOutsideAngular(function () {
            _this.shouldRender();
        });
    };
    /**
     * @return {?}
     */
    FeatureToggleComponent.prototype.shouldRender = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var showWhenDisabled = this._el.nativeElement.getAttribute('showWhenDisabled') !== null;
        /** @type {?} */
        var toggleState = isOn(this.featureName);
        return toggleState === !showWhenDisabled;
    };
    FeatureToggleComponent.decorators = [
        { type: Component, args: [{
                    selector: 'feature-toggle',
                    template: '<ng-content *ngIf="shouldRender()"></ng-content>'
                }] }
    ];
    /** @nocollapse */
    FeatureToggleComponent.ctorParameters = function () { return [
        { type: ElementRef },
        { type: NgZone }
    ]; };
    FeatureToggleComponent.propDecorators = {
        featureName: [{ type: Input }]
    };
    return FeatureToggleComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FeatureToggleProviderComponent = /** @class */ (function () {
    function FeatureToggleProviderComponent() {
        this.features = {};
        this.currentConfig = {};
    }
    /**
     * @return {?}
     */
    FeatureToggleProviderComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (typeof this.features !== 'object') {
            throw new Error('Attribute `features` should not be null or empty');
        }
        this.setFeatureToggles();
    };
    /**
     * @return {?}
     */
    FeatureToggleProviderComponent.prototype.ngDoCheck = /**
     * @return {?}
     */
    function () {
        this.setFeatureToggles();
    };
    /**
     * @private
     * @return {?}
     */
    FeatureToggleProviderComponent.prototype.setFeatureToggles = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.currentConfig !== this.features) {
            this.currentConfig = this.features;
            set(this.features);
        }
    };
    FeatureToggleProviderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'feature-toggle-provider',
                    template: "\n    <ng-content></ng-content>\n  "
                }] }
    ];
    FeatureToggleProviderComponent.propDecorators = {
        features: [{ type: Input }]
    };
    return FeatureToggleProviderComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FeatureToggleModule = /** @class */ (function () {
    function FeatureToggleModule() {
    }
    FeatureToggleModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [FeatureToggleProviderComponent, FeatureToggleComponent],
                    exports: [FeatureToggleProviderComponent, FeatureToggleComponent],
                    imports: [CommonModule],
                },] }
    ];
    return FeatureToggleModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FeatureToggleComponent, FeatureToggleProviderComponent, FeatureToggleModule };

//# sourceMappingURL=ngx-feature-toggle.js.map